@0xbf017710be5a54ff;

using Rust = import "programming_language/rust.capnp";
$Rust.parentModule("schema");

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using AuthenticationSystem = import "authenticationsystem.capnp".AuthenticationSystem;
using MachineSystem = import "machinesystem.capnp".MachineSystem;
using UserSystem = import "usersystem.capnp".UserSystem;
using PermissionSystem = import "permissionsystem.capnp".PermissionSystem;

const api_version_major :Int32  = 0;
const api_version_minor :Int32  = 3;
const api_version_patch :Int32  = 0;

struct Version
{
    major @0 :Int32;
    minor @1 :Int32;
    patch @2 :Int32;
}

interface Bootstrap 
{
    authenticationSystem @0 () -> ( authenticationSystem : AuthenticationSystem );

    machineSystem @1 () -> ( machineSystem : MachineSystem );
    
    userSystem @2 () -> ( userSystem : UserSystem );

    permissionSystem @3 () -> ( permissionSystem : PermissionSystem );

    getAPIVersion @4 () -> ( version : Version );

    getServerVersion @5 () -> ( version : Version );
}
